export default {
  props: {
    debounce: {
      type: Number,
      default: 1e3,
    },
    disabled: Boolean,
    fetch: {
      type: Function,
    },
    filterList: Function,
    list: {
      type: Array,
      default() {
        return [];
      },
    },
    minChars: {
      type: Number,
      default: 1,
    },
    name: String,
    prepareResponseData: Function,
    printAttribute: {
      type: String,
      default: "name",
    },
    queryParam: {
      type: String,
      default: "q",
    },

    maxHeight: {
      type: Number,
      default: 0,
    },

    required: Boolean,

    maxRes: {
      type: Number,
      default: 0,
    },
  },
  methods: {
    onFocus() {
      if (this.parentContainer) {
        this.parentContainer.isFocused = true;
      }
    },
    onBlur() {
      this.parentContainer.isFocused = false;
      this.setParentValue();
    },
    verifyProps() {
      if (!this.parentContainer) {
        return this.throwErrorDestroy(
          "You should wrap the md-input in a md-input-container"
        );
      }
      if (this.listIsEmpty && this.filterList) {
        return this.throwErrorDestroy(
          "You should use a `filterList` function prop with the `list` prop"
        );
      }
      if (!this.fetch && this.listIsEmpty) {
        return this.throwErrorDestroy("You should use a `fetch` function prop");
      }
    },
    throwErrorDestroy(errorMessage) {
      this.$destroy();
      throw new Error(errorMessage);
    },
  },
};
